VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   Caption         =   "Form1"
   ClientHeight    =   6780
   ClientLeft      =   60
   ClientTop       =   300
   ClientWidth     =   8340
   DrawWidth       =   4
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   452
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   556
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox CheckLabels 
      Caption         =   "Labels"
      Height          =   255
      Left            =   4800
      TabIndex        =   8
      Top             =   60
      Value           =   1  'Checked
      Width           =   855
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   315
      Left            =   3780
      TabIndex        =   7
      Top             =   0
      Width           =   975
   End
   Begin VB.PictureBox Picture1 
      Height          =   435
      Left            =   1800
      ScaleHeight     =   375
      ScaleWidth      =   1395
      TabIndex        =   0
      Top             =   0
      Width           =   1455
      Begin VB.Label LabelFOV 
         AutoSize        =   -1  'True
         Caption         =   "Label1"
         Height          =   195
         Left            =   960
         TabIndex        =   6
         Top             =   180
         Width           =   480
      End
      Begin VB.Label LabelEl 
         AutoSize        =   -1  'True
         Caption         =   "Label1"
         Height          =   195
         Left            =   480
         TabIndex        =   5
         Top             =   180
         Width           =   480
      End
      Begin VB.Label LabelRo 
         AutoSize        =   -1  'True
         Caption         =   "Label1"
         Height          =   195
         Left            =   0
         TabIndex        =   4
         Top             =   180
         Width           =   480
      End
      Begin VB.Label LabelZ 
         AutoSize        =   -1  'True
         Caption         =   "Label1"
         Height          =   195
         Left            =   960
         TabIndex        =   3
         Top             =   0
         Width           =   480
      End
      Begin VB.Label LabelY 
         AutoSize        =   -1  'True
         Caption         =   "Label1"
         Height          =   195
         Left            =   480
         TabIndex        =   2
         Top             =   0
         Width           =   480
      End
      Begin VB.Label LabelX 
         AutoSize        =   -1  'True
         Caption         =   "Label1"
         Height          =   195
         Left            =   0
         TabIndex        =   1
         Top             =   0
         Width           =   480
      End
   End
   Begin VB.Timer Timer1 
      Interval        =   10
      Left            =   3300
      Top             =   0
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private ShipMove As Boolean

Private Sub initEntity(index%, numLines)
    Dim i%
    With entity(index)
        ReDim .vertex(numLines)
        For i = 0 To numLines
            With .vertex(i)
                .colour = RGB(0, 0, 0)
                .x = 0
                .y = 0
                .z = 0
                ReDim .connect(numLines)
            End With
            unlink index, i
        Next i
        .visible = False
    End With
End Sub
Private Sub normalise(ent As entity)
    Dim i, x As Double, y As Double, z As Double
    For i = 0 To UBound(ent.vertex)
        x = x + ent.vertex(i).x
        y = y + ent.vertex(i).y
        z = z + ent.vertex(i).z
    Next i
    x = x / i
    y = y / i
    z = z / i
    For i = 0 To UBound(ent.vertex)
        ent.vertex(i).x = ent.vertex(i).x - x
        ent.vertex(i).y = ent.vertex(i).y - y
        ent.vertex(i).z = ent.vertex(i).z - z
    Next i
    
End Sub
Private Sub Command1_Click()
    Timer1_Timer
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
'    MsgBox KeyCode
    Select Case KeyCode
        Case 188
            turnRollLeft = 1
        Case 190
            turnRollRight = 1
        Case 37
            turnLeft = 1
        Case 38
            turnDown = 1
        Case 39
            turnRight = 1
        Case 40
            turnUp = 1
        Case 68
            moveRight = 1
        Case 65
            moveLeft = 1
        Case 87
            moveForward = 1
        Case 83
            moveBackward = 1
        Case 16
            moveUp = 1
        Case 32
            moveDown = 1
        Case 13
            ShipMove = Not ShipMove
    End Select
        
End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
'    MsgBox KeyCode
    Select Case KeyCode
        Case 188
            turnRollLeft = 0
        Case 190
            turnRollRight = 0
        Case 37
            turnLeft = 0
        Case 38
            turnDown = 0
        Case 39
            turnRight = 0
        Case 40
            turnUp = 0
        Case 68
            moveRight = 0
        Case 65
            moveLeft = 0
        Case 87
            moveForward = 0
        Case 83
            moveBackward = 0
        Case 16
            moveUp = 0
        Case 32
            moveDown = 0
    End Select
End Sub

Private Sub Form_Load()
    Dim i%, x%, y%, colour1 As Long
    
    selfPos = Vect(0, 0, 0)
    selfAng.pitch = 0
    selfAng.yaw = 0
    l.z = 1
    u.y = 1
    
    
    speed = 0.1
    sens = 3
    
    FOV = 90
    LabelFOV = FOV
        
        initEntity 0, 7
        setpos 0, 0, 0, 0, 0, RGB(255, 255, 0)
        link 0, 0, 4
        setpos 0, 1, 1, 0, 0, RGB(255, 255, 0)
        link 0, 1, 5
        setpos 0, 2, 1, 0, 1, RGB(255, 255, 0)
        link 0, 2, 6
        setpos 0, 3, 0, 0, 1, RGB(255, 255, 0)
        link 0, 3, 7
        setpos 0, 4, 0, 1, 0, RGB(255, 0, 0)
        link 0, 4, 5
        setpos 0, 5, 1, 1, 0, RGB(255, 0, 0)
        link 0, 5, 6
        setpos 0, 6, 1, 1, 1, RGB(255, 0, 0)
        link 0, 6, 7
        setpos 0, 7, 0, 1, 1, RGB(255, 0, 0)
        link 0, 7, 4
        entity(0).visible = True
        entity(0).name = "table"
        entity(0).pos = Vect(0, 0, 0)
        initEntity 1, 63

        colour1 = RGB(32, 128, 0)
        For x = 0 To 7
            For y = 0 To 7
                setpos 1, x + y * 8, x / 2 - 1, 0, y / 2 - 1, colour1
            Next y
        Next x
        For x = 0 To 6
            For y = 0 To 6
                link 1, x + y * 8, x + y * 8 + 1
                link 1, x + y * 8, x + y * 8 + 8
            Next y
        Next x
        For y = 0 To 6
            link 1, 7 + y * 8, 7 + y * 8 + 8
        Next y
        For x = 0 To 6
            link 1, x + 7 * 8, x + 7 * 8 + 1
        Next x
        entity(1).visible = True
        entity(1).name = "floor"
        entity(1).pos = Vect(0, 0, 0)
    
    initEntity 2, 6
    setpos 2, 0, 0, 0, 0, RGB(0, 0, 0)
    setpos 2, 1, 1, 0, 0, RGB(0, 0, 0)
    setpos 2, 2, 0, 1, 0, RGB(255, 0, 0), "n"
    setpos 2, 3, 0, 0, 1, RGB(0, 0, 255), "L"
    setpos 2, 4, -1, 0, 0, RGB(0, 0, 0)
    setpos 2, 5, 0, -1, 0, RGB(0, 0, 0)
    setpos 2, 6, 0, 0, -1, RGB(0, 0, 0)
    link 2, 0, 1
    link 2, 2, 0
    link 2, 3, 0
    link 2, 0, 4
    link 2, 0, 5
    link 2, 0, 6
    entity(2).name = "cross"
    entity(2).visible = False
    
    initEntity 3, 5
    setpos 3, 0, 0, 0, 0, 0, "0"
    setpos 3, 1, -0.5, 0, 1, 0, "1"
    setpos 3, 2, -0.3, 0.2, 1, 0, "2"
    setpos 3, 3, 0, 0, 1, 0, "3"
    setpos 3, 4, 0.3, 0.2, 1, 0, "4"
    setpos 3, 5, 0.5, 0, 1, 0, "5"
    link 3, 0, 1
    link 3, 0, 2
    link 3, 0, 4
    link 3, 0, 5
    link 3, 2, 1
    link 3, 2, 3
    link 3, 4, 3
    link 3, 4, 5
    link 3, 1, 3
    link 3, 5, 3
    link 3, 2, 4
    
    entity(3).visible = True
    entity(3).name = "viper"
    entity(3).pos = Vect(0, 0.3, 0)
    normalise entity(3)
End Sub
Private Sub link(ent%, ver%, num%)
    entity(ent).vertex(ver).connect(num) = True
End Sub
Private Sub unlink(ent%, ver%)
    Dim i%
    For i = 0 To UBound(entity(ent).vertex(ver).connect)
        entity(ent).vertex(ver).connect(i) = False
    Next i
End Sub
Private Sub setpos(ent%, ver%, x As Single, y As Single, z As Single, col As Long, Optional label$ = "")
    Dim i%
    With entity(ent).vertex(ver)
        .x = x
        .y = y
        .z = z
        .colour = col
        .label = label
    End With
End Sub
Private Function pos(x As Single, y As Single, z As Single, col As Long) As particle
    pos.x = x
    pos.y = y
    pos.z = z
    pos.colour = col
End Function
Private Sub draw()
    On Error Resume Next
    Dim i%, i2%, i3%, i4 As Single
    Dim x As Double, y As Double
    Dim x2 As Double, y2 As Double
    Dim ang As Angle
    Dim total%, dx%, dy%, dx2%, dy2%
    Dim red%, green%, blue%, endOfLine As Boolean
    Dim distance As Double, oldX As Double, oldY As Double
    Dim tempVert As particle
    Cls
    Print "l=" & deVect(l, 3)
    Print "n=" & deVect(n, 3)
    Print "n2=" & deVect(n2, 3)
    Print "u=" & deVect(u, 3)
    Print "w=" & deVect(w, 3)
    For i = UBound(entity) To 0 Step -1
        With entity(i)
            If .visible Then
                For i2 = 0 To UBound(.vertex)
                    ang = angleOfP(entity(i), .vertex(i2))
                    x = ang.yaw / FOV
                    y = ang.pitch / FOV
                    dx = x * Form1.ScaleWidth + Form1.ScaleWidth / 2
                    dy = (-y) * Form1.ScaleHeight + Form1.ScaleHeight / 2
                    Form1.DrawWidth = 3: If Not offScreen(dx, dy) Then PSet (dx, dy), .vertex(i2).colour: If CheckLabels Then Print .vertex(i2).label
'                    PSet (dx, dy), .vertex(i2).colour
                    total = 0
                    For i3 = 0 To UBound(.vertex(i2).connect)
                        If .vertex(i2).connect(i3) Then
                            i4 = 0.1
                            distance = ((.vertex(i3).x - .vertex(i2).x) ^ 2 + (.vertex(i3).y - .vertex(i2).y) ^ 2 + (.vertex(i3).z - .vertex(i2).z) ^ 2) ^ 0.5
                            endOfLine = False
                            oldX = dx
                            oldY = dy
                            Do
                                If i4 = 1 Then endOfLine = True
                                tempVert.x = i4 * (.vertex(i3).x - .vertex(i2).x) + .vertex(i2).x
                                tempVert.y = i4 * (.vertex(i3).y - .vertex(i2).y) + .vertex(i2).y
                                tempVert.z = i4 * (.vertex(i3).z - .vertex(i2).z) + .vertex(i2).z
                                red = i4 * (GetRed(.vertex(i3).colour) + -GetRed(.vertex(i2).colour)) + GetRed(.vertex(i2).colour)
                                green = i4 * (GetGreen(.vertex(i3).colour) + -GetGreen(.vertex(i2).colour)) + GetGreen(.vertex(i2).colour)
                                blue = i4 * (GetBlue(.vertex(i3).colour) + -GetBlue(.vertex(i2).colour)) + GetBlue(.vertex(i2).colour)
                                tempVert.colour = RGB(red, green, blue)
                                ang = angleOfP(entity(i), tempVert)
                                x2 = ang.yaw / FOV
                                y2 = ang.pitch / FOV
                                dx2 = x2 * Form1.ScaleWidth + Form1.ScaleWidth / 2
                                dy2 = (-y2) * Form1.ScaleHeight + Form1.ScaleHeight / 2
                                Form1.DrawWidth = 1
                                If Not (offScreen(dx, dy) And offScreen(dx2, dy2)) Then
                                    If i4 = 0 Then
'                                        PSet (dx2, dy2), tempVert.colour
                                    Else
                                        Line (oldX, oldY)-(dx2, dy2), tempVert.colour
                                    End If
                                End If
                                oldX = dx2
                                oldY = dy2
                                i4 = i4 + 0.1
                                If i4 > 1 Then i4 = 1
                            Loop Until endOfLine
                        End If
                    Next i3
                Next i2
            End If
        End With
    Next i
End Sub
Private Function offScreen(x, y) As Boolean
    If x > Form1.ScaleWidth Or x < Form1.ScaleLeft Or y > Form1.ScaleHeight Or y < Form1.ScaleTop Then offScreen = True
End Function
Private Function angleOfP(ent As entity, p2 As particle) As Angle
    On Error Resume Next
    Dim theta As Double, theta2 As Double
    
    Dim p As vector, r As vector, r2 As vector, a As vector, b As Double
    
    checkNok
    
    p = Vect(ent.pos.x + p2.x - selfPos.x, ent.pos.y + p2.y - selfPos.y, ent.pos.z + p2.z - selfPos.z) 'change origin to player
    
    If Mag(p) > 0 Then
        theta = DotProd(p, n)
        
        r.x = p.x - theta * n.x
        r.y = p.y - theta * n.y
        r.z = p.z - theta * n.z
        r = Unit(r)
        
        theta2 = DotProd(p, n2)
        
        r2.x = p.x - theta2 * n2.x
        r2.y = p.y - theta2 * n2.y
        r2.z = p.z - theta2 * n2.z
        r2 = Unit(r2)
        
        'l is vector looking in (forefinger)
        
        'n is 'thumb' vector
        
        'p is position vector to particle
        
        'r is poition vector to "point 'line from p in direction n' interesects with 'plane L' "
        
        angleOfP.yaw = arccos(DotProd(r, l))
        angleOfP.pitch = arccos(DotProd(r2, l))
        
        If Not (Round(10, l.x) = Round(10, r.x) Or Round(10, l.x) = -Round(10, r.x)) Or Not (Round(10, l.y) = Round(10, r.y) Or Round(10, l.y) = -Round(10, r.y)) Or Not (Round(10, l.z) = Round(10, r.z) Or Round(10, l.z) = -Round(10, r.z)) Then
            a = CrossProd(l, r)
            a = Unit(a)
            
            If Round(5, a.x) <> 0 Then b = a.x / n.x
            If Round(5, a.y) <> 0 Then b = a.y / n.y
            If Round(5, a.z) <> 0 Then b = a.z / n.z
            
            angleOfP.yaw = angleOfP.yaw * b
        End If
        
        If Not deVect(l, 10) = deVect(r2, 10) Then
            a = CrossProd(r2, l)
            a = Unit(a)
            
            If Round(5, a.x) <> 0 Then b = a.x / n2.x
            If Round(5, a.y) <> 0 Then b = a.y / n2.y
            If Round(5, a.z) <> 0 Then b = a.z / n2.z
        End If
        angleOfP.pitch = angleOfP.pitch * b
    End If
    
End Function
Private Sub LabelEl_Click()
    selfAng.pitch = Val(InputBox("Please enter the pitch Angle", selfAng.pitch))
End Sub
Private Sub LabelFOV_Click()
    FOV = Val(InputBox("Please enter the Field of Vision (90)", FOV))
    If FOV = 0 Then FOV = 90
    LabelFOV = FOV
End Sub
Private Sub LabelRo_Click()
    selfAng.yaw = Val(InputBox("Please enter the yaw Angle", selfAng.yaw))
End Sub

Private Sub LabelX_Click()
    selfPos.x = Val(InputBox("Please enter the X", selfPos.x))
End Sub

Private Sub LabelY_Click()
    selfPos.y = Val(InputBox("Please enter the Y", selfPos.y))
End Sub

Private Sub LabelZ_Click()
    selfPos.z = Val(InputBox("Please enter the Z", selfPos.z))
End Sub

Private Sub Timer1_Timer()
    Dim remDir As Angle
    If turnRollLeft Then
        checkNok
        selfRoll = selfRoll - sens
        If selfRoll < 0 Then selfRoll = selfRoll + 360
        nOk = False
    End If
    If turnRollRight Then
        checkNok
        selfRoll = selfRoll + sens
        If selfRoll > 360 Then selfRoll = selfRoll - 360
        nOk = False
    End If
    If turnRight Then
        checkNok
        l = turnVect(l, n2, CDbl(sens))
        
  '     updateDirFromL
        nOk = False
    End If
    If turnLeft Then
        checkNok
        l = turnVect(l, n2, CDbl(-sens))
 '       updateDirFromL
        nOk = False
    End If
    If turnUp Then
        checkNok
        l = turnVect(l, n, CDbl(sens))
'        updateDirFromL
        nOk = False
    End If
    If turnDown Then
        checkNok
        l = turnVect(l, n, CDbl(-sens))
'        updateDirFromL
        nOk = False
    End If
        
    
    If moveLeft Then
        checkNok
        selfPos.x = selfPos.x - n2.x * speed
        selfPos.y = selfPos.y - n2.y * speed
        selfPos.z = selfPos.z - n2.z * speed
    End If
    If moveRight Then
        checkNok
        selfPos.x = selfPos.x + n2.x * speed
        selfPos.y = selfPos.y + n2.y * speed
        selfPos.z = selfPos.z + n2.z * speed
    End If
    If moveUp Then
        checkNok
        selfPos.x = selfPos.x + n.x * speed
        selfPos.y = selfPos.y + n.y * speed
        selfPos.z = selfPos.z + n.z * speed
    End If
    If moveDown Then
        checkNok
        selfPos.x = selfPos.x - n.x * speed
        selfPos.y = selfPos.y - n.y * speed
        selfPos.z = selfPos.z - n.z * speed
    End If
    If moveForward Then
        checkNok
        selfPos.x = selfPos.x + l.x * speed
        selfPos.y = selfPos.y + l.y * speed
        selfPos.z = selfPos.z + l.z * speed
    End If
    If moveBackward Then
        checkNok
        selfPos.x = selfPos.x - l.x * speed
        selfPos.y = selfPos.y - l.y * speed
        selfPos.z = selfPos.z - l.z * speed
    End If
    LabelX = Int(selfPos.x * 100) / 100
    LabelY = Int(selfPos.y * 100) / 100
    LabelZ = Int(selfPos.z * 100) / 100
    LabelRo = Int(selfAng.yaw * 100) / 100
    LabelEl = Int(selfAng.pitch * 100) / 100
    If moveLeft Or moveRight Or moveUp Or moveDown Or moveForward Or moveBackward Then nOk = False
    If turnLeft Or turnRight Or turnUp Or turnDown Or turnRollLeft Or turnRollRight Then nOk = False
    draw
    If ShipMove Then entity(3).pos.z = entity(3).pos.z - 0.05
End Sub
Public Sub checkNok()
   If Not nOk Then
'        l = Dirc(selfAng)
        w = CrossProd(l, Vect(0, 1, 0))
        u = CrossProd(w, l)
'        u = Dirc(makeAng(selfAng.yaw, selfAng.pitch + 90))
        n = turnVect(u, w, selfRoll)
        n = Unit(n)
        n2 = CrossProd(n, l)
        n2 = Unit(n2)
        nOk = True
    End If
End Sub

